unit ncadCtrlXUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  nanoCAD_TLB, OdaX_TLB, ComObj,
  iniFiles;

type
  TForm72 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    ComboBox1: TComboBox;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button24Click(Sender: TObject);
    procedure Button25Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form72: TForm72;

// vg^Cv
function GetInters(p1, p2, p3, p4: OleVariant; onTheFlag: boolean; var respt: OleVariant): boolean;
function GetDistance(p1, p2: OleVariant):double;
function GetPolar(p0: OleVariant; rad, dist: double): OleVariant;
function GetAngle(p1, p2: OleVariant): double;
function PlusPoint(pt, dpt: OleVariant): OleVariant;
function MinusPoint(pt, dpt: OleVariant): OleVariant;
function RotatePoint(pt: OleVariant; rad: double): OleVariant;
function RotatePointBase(base, pt: OleVariant; rad: double): OleVariant;

implementation

{$R *.dfm}

// LWPOLYLINE42̒l璆S,aAJnradAIraď`ɕς
// QlF uVEDXFt@XKChvidIoBPЁj
procedure BulgeToArc(p1, p2: OleVariant; bulge: double;
  var p0: OleVariant; var r: double; var st: double; var ed: double);
var
  naikaku, d, hankei, kakudo1: double;
begin
  //c݂AARC̒S̓p߂
  naikaku := arctan(bulge) * 4.0;
  //ARC̎n_|I_Ԃ̋̂P^Q߂
  d := GetDistance(p1, p2) / 2.0;
  //a߂
  hankei := d / sin(naikaku / 2.0);
  r := abs(hankei);
  //SW߂
  kakudo1 := pi / 2.0 - naikaku / 2.0;
  p0 := GetPolar(p1, kakudo1 + GetAngle(p1, p2), hankei);
  //c݂̒lɂn_I_ւ
  if bulge < 0.0 then begin
    st := GetAngle(p0, p2);
    ed := GetAngle(p0, p1);
  end
  else begin
    st := GetAngle(p0, p1);
    ed := GetAngle(p0, p2);
  end;
end;

//|Cgpxrad ̋dist̓_
function GetPolar(p0: OleVariant; rad, dist: double): OleVariant;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  result[2] := 0;
  if rad = 0 then begin
   result[0] := dist + p0[0];
   result[1] := p0[1];
  end
  else if rad = PI/2 then begin
   result[0] := p0[0];
   result[1] := dist + p0[1];
  end
  else if rad = PI then begin
   result[0] := p0[0] - dist;
   result[1] := p0[1];
  end
  else if rad = PI*1.5 then begin
   result[0] := p0[0];
   result[1] := p0[1] - dist;
  end
  else begin
   result[0] := dist * cos(rad) + p0[0];
   result[1] := dist * sin(rad) + p0[1];
  end;
end;

// 2d
function GetDistance(p1, p2: OleVariant): double;
begin
  Result := sqrt(sqr(p1[1] - p2[1]) + sqr(p1[0] - p2[0]));
end;

// Q_̊px
function GetAngle(p1, p2: OleVariant): double;
var
  ang, x, y : double;
begin
  x := p2[0] - p1[0];
  y := p2[1] - p1[1];
  if abs(x) < 10e-6 then begin
    if p1[1] < p2[1] then ang := pi * 0.5 else ang := pi * 1.5;
  end
  else if abs(y)< 10e-6 then begin
    if p1[0] < p2[0] then ang := 0 else ang := pi;
  end
  else begin
    ang := abs(ArcTan(y / x));
    if (x < 0.0) and (y >= 0.0) then ang := pi - ang
    else if (x >= 0.0) and (y < 0.0) then ang := pi * 2.0 - ang
    else if (x < 0.0) and (y < 0.0) then ang := ang + pi;
  end;
  result := ang;
end;

//4_꒼ijɂ邩
function IsOnTheSameLine(p1, p2, p3, p4: OleVariant; gosa: double): boolean;
var
  ang, lg1, lg2: double;
begin
  result := false;
  ang := GetAngle(p1, p2);
  lg1 := GetDistance(p1, p3) * sin(ang - GetAngle(p1, p3));
  if abs(lg1) < gosa then begin
    lg2 := GetDistance(p1, p4) * sin(ang - GetAngle(p1, p4));
    result := abs(lg2) < gosa;
  end;
end;

//4_꒼ijɂ邩
function IsOnTheSameLine2(p1, p2, p3, p4: OleVariant; gosa: double): boolean;
var
  ang: double;
begin
  ang := GetAngle(p1, p2);
  p3 := RotatePointBase(p1, p3, -ang);
  p4 := RotatePointBase(p1, p4, -ang);
  result := (abs(p3[1]-p1[1]) <= gosa) and  (abs(p4[1]-p1[1]) <= gosa);
end;

// Q̌_𓾂( [__Ƃ)
function GetInters(p1, p2, p3, p4: OleVariant; onTheFlag: boolean; var respt: OleVariant): boolean;
var
  f1, f2, g1, g2, h, m, n: double;
begin
  Result := False;
  if (getDistance(p1, p3) <= 10e-13) or (getDistance(p1, p4) <= 10e-13) then begin
    result := True;
    respt := p1;
  end
  else if (getDistance(p2, p3) <= 10e-13) or (getDistance(p2, p4) <= 10e-13) then begin
    result := True;
    respt := p2;
  end
  else begin
    f1 := p2[0] - p1[0];
    f2 := p4[0] - p3[0];
    g1 := p2[1] - p1[1];
    g2 := p4[1] - p3[1];
    h := f2 * g1 - f1 * g2;
    if abs(h) > 10e-13 then begin //słȂ
      m := (f2 * (p3[1] - p1[1]) - g2 * (p3[0] - p1[0])) / h;
      n := (f1 * (p3[1] - p1[1]) - g1 * (p3[0] - p1[0])) / h;
      if (((n >= 10e-13) and (n <= 1)) and ((m >= 10e-13) and (m <= 1))) or not onTheFlag then begin //_ɑ
        respt[0] := p1[0] +m * (p2[0] - p1[0]);
        respt[1] := p1[1] +m * (p2[1] - p1[1]);
        //respt[2] := p1[2];
        Result := True;
      end;
    end;
  end;
end;

// Z܂ɍW]
function RotatePoint(pt: OleVariant; rad: double): OleVariant;
var
  cosz, sinz: double;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  cosz := Cos(rad);
  sinz := Sin(rad);
  Result[0] := pt[0] * cosz + pt[1] * -sinz;
  Result[1] := pt[0] * sinz + pt[1] * cosz;
  Result[2] := pt[2];
end;

//Wg/k
function ScalePoint(pt: OleVariant; scale: double): OleVariant;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  Result[0] := pt[0] * scale;
  Result[1] := pt[1] * scale;
  Result[2] := pt[2] * scale;
end;

//Wg/k
function ScalePointBase(pt: OleVariant; scpt: OleVariant): OleVariant;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  Result[0] := pt[0] * scpt[0];
  Result[1] := pt[1] * scpt[1];
  Result[2] := pt[2] * scpt[2];
end;

function Equal2dPoint(p1, p2: OleVariant; gosa: double): boolean;
begin
  result:= (abs(p1[0]-p2[0]) < gosa) and (abs(p1[1]-p2[1]) < gosa);
  //result:= SameValue(p1[0], p2[0],gosa) and SameValue(p1[1],p2[1],gosa);
end;

function RotatePointBase(base, pt: OleVariant; rad: double): OleVariant;
var
  cosz,sinz: double;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  cosz := Cos(rad);
  sinz := Sin(rad);
  Result[0] := base[0] + (pt[0] - base[0]) * cosz + (pt[1] - base[1]) * -sinz;
  Result[1] := base[1] + (pt[0] - base[0]) * sinz + (pt[1] - base[1]) * cosz;
  Result[2] := pt[2];
end;

function IsOnTheLine(p0, p1, p2: OleVariant; gosa: double):boolean;
begin
  result := abs(GetDistance(p1, p2) - GetDistance(p0, p1) - GetDistance(p0, p2)) <= gosa;
end;

function GetPerPoint(p0, p1, p2: OleVariant; var respt: OleVariant):boolean;
var
  kp : OleVariant;
  pt : OleVariant;
begin
  result := false;
  kp := VarArrayCreate([0,1],VarDouble);
  pt := GetPolar(p0, GetAngle(p1,p2) + PI/2.0, 1000);
  if GetInters(p0, pt, p1, p2, False, kp) then begin
    respt := kp;
    result := IsOnTheLine(kp, p1, p2, 10e-8);
  end;
end;

function GetPerPoint2(p0, p1, p2: OleVariant; OnLineFlag:boolean; var respt: OleVariant):boolean;
var
  p0a: OleVariant;
  p2a: OleVariant;
  ang: double;
begin
  respt := VarArrayCreate([0, 2], VarDouble);
  respt[2] := 0;
  ang := getAngle(p1, p2);

  p0a := minusPoint(p0, p1);
  p0a := RotatePoint(p0a, -ang);
  p2a := minusPoint(p2, p1);
  p2a := RotatePoint(p2a, -ang);
  respt[0] := p0a[0];
  respt[1] := 0;
  respt := RotatePoint(respt, ang);
  respt := PlusPoint(respt, p1);
  result := ((p0a[0] >= 0) and (p0a[0] <= p2a[0]));
end;

//R_̒S𓾂
function Get3PointCenter(p1, p2, p3: OleVariant): OleVariant;
var
  p0, p1a, p3a: OleVariant;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  p1a := VarArrayCreate([0, 2], VarDouble);
  p3a := VarArrayCreate([0, 2], VarDouble);
  p0  := VarArrayCreate([0, 2], VarDouble);

  p1a := GetPolar(p1, (GetAngle(p1, p2) + GetAngle(p1, p3)) / 2.0, 100);
  p3a := GetPolar(p3, (GetAngle(p3, p1) + GetAngle(p3, p2)) / 2.0, 100);
  GetInters(p1, p1a, p3, p3a, False, p0);
  Result := p0;
end;

//Q_̒_𓾂
function GetMidPoint(p1, p2 :OleVariant): OleVariant;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  Result[0] := (p1[0] + p2[0]) / 2.0;
  Result[1] := (p1[1] + p2[1]) / 2.0;
  Result[2] := (p1[2] + p2[2]) / 2.0;
end;

function CreateVarPoint(x, y, z: Double): OleVariant;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  result[0] := x;
  result[1] := y;
  result[2] := z;
end;

function CreateVarPoint2d(x, y: Double):OleVariant;
begin
  result := VarArrayCreate([0, 1], VarDouble);
  result[0] := x;
  result[1] := y;
end;

function IsPararel(p1, p2, p3, p4: OleVariant): boolean;
var
  f1, f2, g1, g2, h: double;
begin
  f1 := p2[0] - p1[0];
  f2 := p4[0] - p3[0];
  g1 := p2[1] - p1[1];
  g2 := p4[1] - p3[1];
  h := f2 * g1 - f1 * g2;
  result := abs(h) <= 10e-13; //s
end;

//WړiZj
function PlusPoint(pt, dpt: OleVariant): OleVariant;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  Result[0] := pt[0] + dpt[0];
  Result[1] := pt[1] + dpt[1];
  Result[2] := pt[2] + dpt[2];
end;
function MinusPoint(pt, dpt: OleVariant): OleVariant;
begin
  result := VarArrayCreate([0, 2], VarDouble);
  Result[0] := pt[0] - dpt[0];
  Result[1] := pt[1] - dpt[1];
  Result[2] := pt[2] - dpt[2];
end;

//WAxɕϊ
function RadToDeg(rad: double): double;
begin
  Result := 180.0 * rad / pi;
end;

//xWAɕϊ
function DegToRad(deg: double): double;
begin
  Result := deg * pi / 180.0;
end;

// ̃vZX̃Rg[̕𓾂
function GetWindowStr(h: HWND): String;
var
  len: integer;
  buf: PChar;
begin
  result := '';
  len := SendMessage(h, WM_GETTEXTLENGTH, 0, 0);
  if len > 0 then begin
    buf := StrAlloc(len + 1);
    try
      SendMessage(h, WM_GETTEXT, StrBufSize(buf), LPARAM(buf));
      result := buf;
    finally
      StrDispose(buf);
    end;
  end;
end;

// R}h̕擾
function ncadCmdHist: String;
var
  h, hCmdHist, hMain: hwnd;
begin
  result := '';

  hMain := FindWindow(nil, 'nanoCAD 5');
  if isWindow(hMain) then begin
    h := FindWindowEx(hMain, 0, nil, 'Command Line');
    h := GetWindow(h, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    hCmdHist := GetWindow(h, GW_HWNDNEXT); // Hist
    result := GetWindowStr(hCmdHist);
  end;
end;
// R}hCi[U[͂镔j̕擾
// R}h̕ł͂Ȃ
function ncadCmdEdit: string;
var
  h, hCmdHist, hCmdEdit, hMain: HWND;
begin
  result := '';

  hMain := FindWindow(nil, 'nanoCAD 5');
  if hMain <> 0 then begin
    h := FindWindowEx(hMain, 0, nil, 'Command Line');
    h := GetWindow(h, GW_CHILD);
    h := GetWindow(h, GW_CHILD);
    hCmdHist := GetWindow(h, GW_HWNDNEXT); // Hist
    hCmdEdit := GetWindow(hCmdHist, GW_HWNDNEXT); // Edit
    result := GetWindowStr(hCmdEdit);
  end;
end;
// ----------------------------------------------------------------------------

procedure makelayerOnlist(doc: InanoCADDocument; sl: TStringList);
// wIŃt[ĂȂw̃Xg쐬
var
  lays: IAcadLayers;
  lay: IAcadLayer;
  i: integer;
begin
  sl.Clear;
  lays := doc.Layers;
  for i := 0 to lays.Count - 1 do begin
    lay := lays.Item(i);
    if (not lay.Freeze) and lay.LayerOn then
      sl.Add(Uppercase(lay.Name)+#09);
  end;
end;

// N nanoCAD 擾
// activate : True ŃANeBuɂ
function FindNcadApp(var app: inanoCADApplication; activate: Boolean): boolean;
var
  hMain: HWND;
begin
  result := False;
  hMain := FindWindow(nil, 'nanoCAD 5');
  if (hMain <> 0) and isWindowEnabled(hMain) then begin
    try
      app := CoApplication.Create;
      if activate then begin
        if app.WindowState = acMin then app.WindowState := acMax;
        setForegroundWindow(app.HWND_);
      end;
      result := True;
    except

    end;
  end;
end;

function IsLayerVisible(doc: InanoCADDocument; const layerName: string): boolean;
// wIŃt[ĂȂ
var
  lays: IAcadLayers;
  lay: IAcadLayer;
  slay: string;
  i: integer;
begin
  result := True;
  slay := Uppercase(layerName);
  lays:= doc.Layers;
  for i:= 0 to lays.Count - 1 do begin
    lay := lays.Item(i);
    if slay = Uppercase(lay.Name) then begin
      result:= (not lay.Freeze) and lay.LayerOn;
      break;
    end;
  end;
end;

function maxDist4p(p1, p2, p3, p4: oleVariant; var respt1, respt2: oleVariant): double;
var
  dist : double;
  pts: Array [0..3] of oleVariant;
  i, j: integer;
begin

  pts[0] :=  p1;
  pts[1] :=  p2;
  pts[2] :=  p3;
  pts[3] :=  p4;

  result := 0;
  for i := 0 to 2 do begin
   for j := i+1 to 3 do begin
     dist := getDistance(pts[i], pts[j]);
     if result < dist then begin
       result := dist;
       respt1 := pts[i];
       respt2 := pts[j];
     end;
   end;
  end;
end;
function maxDistVpts3d(vpts: oleVariant; var respt1, respt2: oleVariant): double;
var
  dist : double;
  pts: Array of oleVariant;
  i, j, h, len : integer;
begin
  h := VarArrayHighBound(vpts, 1);
  len := (h + 1) div 3;
  SetLength(pts, len);
  for i := 0 to len -1 do begin
    pts[i] :=  VarArrayCreate([0, 2], VarDouble);
    pts[i][0] :=  vpts[i*3];
    pts[i][1] :=  vpts[i*3+1];
    pts[i][2] :=  vpts[i*3+2];
  end;

  result := 0;

  if len >= 2 then begin
    for i := 0 to len-2 do begin
     for j := i+1 to len-1 do begin
       dist := getDistance(pts[i], pts[j]);
       if result < dist then begin
         result := dist;
         respt1 := pts[i];
         respt2 := pts[j];
       end;
     end;
    end;
  end
  else begin
    respt1 := pts[0];
  end;
end;
// ----------------------------------------------------------------------------

procedure TForm72.Button10Click(Sender: TObject);
// 
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  layout : IAcadLayout;
  devnames, tablenames: oleVariant;
  i, n, m: integer;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  // 
  try
    doc := app.ActiveDocument;

    layout := doc.ActiveLayout;
    layout.RefreshPlotDeviceInfo;

    devnames := layout.GetPlotDeviceNames;
    n := VarArrayHighBound(devnames, 1);
    Memo1.Lines.Add(' Printer ---------');
    ComboBox1.Items.Clear;
    if n >= 0 then begin
      for i := 0 to n do begin
        Memo1.Lines.Add(devnames[i]);
        ComboBox1.Items.Add(devnames[i]);
      end;

      with ComboBox1 do begin
        ItemIndex := Items.IndexOf(layout.ConfigName);
      end;
    end;
//    Memo1.Lines.Add(' Paper ---------');
//    papernames := layout.GetCanonicalMediaNames;
//
//    n := VarArrayHighBound(papernames, 1);
//    if n >= 0 then begin
//      for i := 0 to n  do begin
//        Memo1.Lines.Add(layout.GetLocaleMediaName(papernames[i]));
//      end;
//    end;
    Memo1.Lines.Add(' Table ---------');
    tablenames := layout.GetPlotStyleTableNames;
    // CTB,STB@ꗗ
    n := VarArrayLowBound(tablenames, 1);
    m := VarArrayHighBound(tablenames, 1);
    if m > 0 then begin
      for i := n to m do
        Memo1.Lines.Add(tablenames[i]);
    end;
  except

  end;
end;

// ĂȂw̃Xg
function makeNotVisibleLayerNames(doc: InanoCadDocument; sl: TStringList): integer;
var
  i:integer;
  lays: IAcadLayers;
  lay: IAcadLayer;
begin
  sl.Clear;
  try
  lays := doc.Layers;
    for i := 0 to lays.Count-1 do begin
      lay := lays.Item(i);
      if not lay.LayerOn or lay.Freeze then
        sl.Add(lay.Name + #09);
    end;
  except

  end;
  result := sl.Count;
end;
// ubŇĂ}`͈͂𓾂
function getBlockRect(doc: InanoCadDocument; const blkName:string;
   var vminpt:oleVariant; var vmaxpt: oleVariant): boolean;
var
  i, j, k: Integer;
  s: string;
  vpt1, vpt2: oleVariant;
  sl: TstringList;
  blks: IAcadBlocks;
  blk: IAcadBlock;
  ent: IAcadEntity;
  cnt: integer;
begin
  result := false;
  sl := TStringList.Create;
  try
    try
      makeNotVisibleLayerNames(doc, sl);
      //Form72.Memo1.Lines.Assign(sl);

      blks := doc.Blocks;
      for i := 0 to blks.Count-1 do begin
        blk := blks.Item(i);
        if blk.Name = blkName  then begin
          vmaxpt := doc.GetVariable('extmin');
          vminpt := doc.GetVariable('extmax');
          cnt := 0;

          for j := 0 to blk.Count -1 do begin
            ent := blk.Item(j);
            s := ent.EntityName;
            if ('AcDbCircle' = s) or ('AcDbArc' = s) or  ('AcDbLine' = s) or ('AcDbPolyline' = s) then begin
              if (sl.Count = 0) or (sl.IndexOf(ent.Layer + #09) < 0) then begin
                ent.GetBoundingBox(vpt1, vpt2);
                for k := 0 to 1 do begin
                  if vmaxpt[k] < vpt1[k] then vmaxpt[k] := vpt1[k];
                  if vminpt[k] > vpt1[k] then vminpt[k] := vpt1[k];
                  if vmaxpt[k] < vpt2[k] then vmaxpt[k] := vpt2[k];
                  if vminpt[k] > vpt2[k] then vminpt[k] := vpt2[k];
                end;
                Inc(cnt);
              end;
            end;
          end;
          result:= cnt>0;
          break;
        end;
      end;
    except

    end;
  finally
    sl.Free;
  end;
end;

function getBlockRealRect(doc: InanoCadDocument; vobj: oleVariant;
          offset1: double; var vpts1:oleVariant): boolean;  overload;
var
  k: Integer;
  vpt1, vpt2: oleVariant;
  vmaxpt, vminpt: oleVariant;
  vmaxpt1, vminpt1: oleVariant;
  pos: OleVariant;
  rot, xsc, ysc: double;
begin
  result:= False;
  try
    if getBlockRect(doc, vobj.Name, vminpt, vmaxpt) then begin
      vmaxpt1:= vmaxpt;
      vminpt1:= vminpt;
      pos := vobj.InsertionPoint;
      xsc := vobj.XScaleFactor;
      ysc := vobj.YScaleFactor;
      rot := vobj.Rotation;
      // offset1
      // ړx
      vminpt1[0] := vminpt[0] * xsc - offset1;
      vmaxpt1[0] := vmaxpt[0] * xsc + offset1;
      vminpt1[1] := vminpt[1] * ysc - offset1;
      vmaxpt1[1] := vmaxpt[1] * ysc + offset1;

      vpt1:= vminpt1;
      vpt1[0]:= vmaxpt1[0];
      vpt2:= vminpt1;
      vpt2[1]:= vmaxpt1[1];
      // ]
      vminpt1 := RotatePoint(vminpt1, rot);
      vmaxpt1 := RotatePoint(vmaxpt1, rot);
      vpt1 := RotatePoint(vpt1, rot);
      vpt2 := RotatePoint(vpt2, rot);
      // ړ
      for k := 0 to 1 do begin
        vminpt1[k] := vminpt1[k] + pos[k];
        vmaxpt1[k] := vmaxpt1[k] + pos[k];
        vpt1[k] := vpt1[k] + pos[k];
        vpt2[k] := vpt2[k] + pos[k];
      end;
      vpts1 := VarArrayCreate([0, 7], VarDouble);
      vpts1[0] := vminpt1[0];
      vpts1[1] := vminpt1[1];
      vpts1[2] := vpt1[0];
      vpts1[3] := vpt1[1];
      vpts1[4] := vmaxpt1[0];
      vpts1[5] := vmaxpt1[1];
      vpts1[6] := vpt2[0];
      vpts1[7] := vpt2[1];

    end;
  except

  end;
end;
function getBlockRealRect(doc: InanoCadDocument; blk: IAcadBlockReference;
          offset1: double; var vpts1:oleVariant): boolean; overload;
var
  k: Integer;
  vpt1, vpt2: oleVariant;
  vmaxpt, vminpt: oleVariant;
  vmaxpt1, vminpt1: oleVariant;
  pos: OleVariant;
  rot, xsc, ysc: double;
begin
  result:= False;
  try
    if getBlockRect(doc, blk.Name, vminpt, vmaxpt) then begin
      vmaxpt1:= vmaxpt;
      vminpt1:= vminpt;
      pos := blk.InsertionPoint;
      xsc := blk.XScaleFactor;
      ysc := blk.YScaleFactor;
      rot := blk.Rotation;
      // offset1
      // ړx
      vminpt1[0] := vminpt[0] * xsc - offset1;
      vmaxpt1[0] := vmaxpt[0] * xsc + offset1;
      vminpt1[1] := vminpt[1] * ysc - offset1;
      vmaxpt1[1] := vmaxpt[1] * ysc + offset1;

      vpt1:= vminpt1;
      vpt1[0]:= vmaxpt1[0];
      vpt2:= vminpt1;
      vpt2[1]:= vmaxpt1[1];
      // ]
      vminpt1 := RotatePoint(vminpt1, rot);
      vmaxpt1 := RotatePoint(vmaxpt1, rot);
      vpt1 := RotatePoint(vpt1, rot);
      vpt2 := RotatePoint(vpt2, rot);
      // ړ
      for k := 0 to 1 do begin
        vminpt1[k] := vminpt1[k] + pos[k];
        vmaxpt1[k] := vmaxpt1[k] + pos[k];
        vpt1[k] := vpt1[k] + pos[k];
        vpt2[k] := vpt2[k] + pos[k];
      end;
      vpts1 := VarArrayCreate([0, 7], VarDouble);
      vpts1[0] := vminpt1[0];
      vpts1[1] := vminpt1[1];
      vpts1[2] := vpt1[0];
      vpts1[3] := vpt1[1];
      vpts1[4] := vmaxpt1[0];
      vpts1[5] := vmaxpt1[1];
      vpts1[6] := vpt2[0];
      vpts1[7] := vpt2[1];


      result:= true;
    end;
  except

  end;
end;

procedure TForm72.Button11Click(Sender: TObject);
// ubN̋`͈́iubN̓}`擾j
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  vpt: OleVariant;
  vobj: OleVariant;

  vpts: oleVariant;
  lwp: IAcadLWPolyline;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  // ubN̋`͈́i 擾̋`͈͂]j
  try
    doc := app.ActiveDocument;
    WindowState:= wsMinimized;
    vobj := VarEmpty;
    doc.Utility.GetEntity(vobj, vpt, 'ubNI');
    if not VarIsEmpty(vobj) then begin
      if 'AcDbBlockReference' = vobj.EntityName then begin
        if getBlockRealRect(doc, vobj, 0, vpts) then begin
          // mF̂ߕ`
          lwp := doc.ModelSpace.AddLightWeightPolyline(vpts);
          lwp.Closed := True;
        end;
      end;
    end;
  except
  end;
  WindowState:= wsNormal;
end;

procedure TForm72.Button12Click(Sender: TObject);
// VXeϐ ATTREQ 邽߁A
// 𖳎đ}
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  blkName: string;
  blks: IAcadBlocks;
  blk: IAcadBlock;
  ent: IAcadEntity;
  i, j: integer;
  s: string;
  attribs: IAcadAttribute;
  //cnt: integer;
  blkref: IAcadBlockReference;
  gen: oleVariant;
  ret: boolean;
  ncadState: InanoCADState;
begin
  Memo1.Lines.Clear;
  gen := VarArrayCreate([0, 2], VarDouble);
  gen[0]:= 0; gen[1] := 0; gen[2] := 0;
  ret:=False;

  if not FindNcadApp(app, true) then exit;
  try
    doc := app.ActiveDocument;
    blkName := Uppercase('ACON2H-1');

    //cnt := 0;
    blks := doc.Blocks;
    for i := 0 to blks.Count-1 do begin
      blk := blks.Item(i);
      if Uppercase(blk.Name) = blkName then begin

        // ȉ͕sv -----------
        for j := 0 to blk.Count -1 do begin
          ent := blk.Item(j);
          s := ent.EntityName;
          if 'AcDbAttributeDefinition' = s then begin
            attribs := ent as IAcadAttribute;
            if not attribs.Constant then begin
              Memo1.Lines.Add(attribs.TagString);
              //Inc(cnt);
            end;
          end;
        end;
        // ܂ŕsv --------

        ret:= True;
        break;
      end;
    end;
    if ret then begin
      blkref := doc.ModelSpace.InsertBlock(gen, blkName, 1, 1, 1, 0, EmptyParam);
      doc.SendCommand('^C^C');
      doc.SendCommand('copybase' + #13 + 'last' + #13#13 + '0,0,0'+#13);
      blkref.Delete;
      //doc.SendCommand('erase' + #13 + 'last' + #13#13);
      WindowState:= wsMinimized;
      doc.SendCommand('pasteclip' + #13);

      for i := 0 to (60 * 1000 div 100) -1 do begin
        Sleep(100);
        vcl.Forms.Application.ProcessMessages; // dv
        if GetKeyState( VK_ESCAPE ) < 0 then begin
          //doc.Utility.Prompt('COMMAND Cancelled!');
          break;
        end
        else begin
          ncadState := app.GetState as InanoCADState;
    @@@if ncadState.IsQuiescent then begin
            //doc.Utility.Prompt('COMMAND Terminated!');
            break;
          end;
        end;
      end;
    end;
  except

  end;
  WindowState:= wsNormal;
end;

procedure TForm72.Button13Click(Sender: TObject);
// ubN̋`͈
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  vpt: OleVariant;
  vobj: OleVariant;

  vpt1, vpt2, vpts: oleVariant;
  lwp: IAcadLWPolyline;
  Ticks: Cardinal;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  // ubN̋`͈́i 擾̋`͈͂]j
  try
    doc := app.ActiveDocument;
    try
      WindowState:= wsMinimized;
      vobj := VarEmpty;
      doc.Utility.GetEntity(vobj, vpt, 'ubNI');
      if not VarIsEmpty(vobj) then begin

        if 'AcDbBlockReference' = vobj.EntityName then begin
          Ticks := GetTickCount;
          vobj.GetBoundingBox(vpt1, vpt2);

          vpts := VarArrayCreate([0, 7], VarDouble);
          vpts[0] := vpt1[0];
          vpts[1] := vpt1[1];
          vpts[2] := vpt2[0];
          vpts[3] := vpt1[1];
          vpts[4] := vpt2[0];
          vpts[5] := vpt2[1];
          vpts[6] := vpt1[0];
          vpts[7] := vpt2[1];
          lwp := doc.ModelSpace.AddLightWeightPolyline(vpts);
          lwp.Closed := True;
          Memo1.Lines.Add((GetTickCount-Ticks).ToString+ 'msec');
        end;
      end;
    except
    end;
  except
  end;
  WindowState:= wsNormal;
end;

procedure TForm72.Button14Click(Sender: TObject);
// t@CI_CAO
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  format, folder, fname: string;
begin
  Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  try
    //Memo1.Lines.Add(app.Path);
    doc := app.ActiveDocument;
    //Memo1.Lines.Add(doc.FullName);
    format := '"dwgFiles (*.dwg)|*.dwg|DWG-bmpFiles (*DWG.bmp)|*_DWG.bmp|DXF-bmpFiles (*DXF.bmp)|*_DXF.bmp';
    folder := ExtractFilePath(doc.FullName);
    fname := doc.Utility.ChooseFile('Select an DWG file', format, 12, folder);
    Memo1.Lines.Add(fname);
  except

  end;
end;

procedure TForm72.Button15Click(Sender: TObject);
// NExcel 
var
  excel: oleVariant;
begin
  Memo1.Lines.Clear;
  try
    excel := GetActiveOleObject('Excel.Application');
    Memo1.Lines.Add(excel.Caption);
    excel.Range('A1'):= 'TEST';
    excel:= UnAssigned;
  except
    if not VarIsEmpty(excel) then
      excel:= UnAssigned;
  end;
end;

procedure TForm72.Button16Click(Sender: TObject);
// N
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  sop, sfile, sparam, sdir: string;
begin
  Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  try
    doc := app.ActiveDocument;
    //ShellExec(op As String, file As String, [param As String], [dir As String], [flags As Long = 1])
    sop := 'open';
    sFile := 'NotePad';
    sParam := ExtractFilePath(app.Path) + 'nCad.cfg';
    sDir :='';
    doc.Utility.ShellExec(sop, sFile, sParam, sDir, 1);
  except

  end;
end;

procedure TForm72.Button17Click(Sender: TObject);
// GNZN
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  sop, sfile, sparam, sdir: string;
begin
  Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  try
    doc := app.ActiveDocument;
    //ShellExec(op As String, file As String, [param As String], [dir As String], [flags As Long = 1])
    sop := 'open';
    sFile := 'EXCEL';
    sParam := '';
    sDir := '';
    doc.Utility.ShellExec(sop, sFile, sParam, sDir, 1);
  except

  end;
end;

procedure TForm72.Button18Click(Sender: TObject);
begin
  // R}h
  Memo1.Lines.Text:= ncadCmdHist;
end;

// I̐̂A꒼̐
// UNDO łȂ̂Ŏps
procedure TForm72.Button19Click(Sender: TObject);
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  ss: InanoCADSelectionset;
  filterType, filterData: OleVariant;
  i,j: integer;
  lin1, lin2: IAcadLine;
  respt1, respt2: OleVariant;
begin
 Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  try
    filterType := VarArrayCreate([0, 0], varSmallInt);
    filterData := VarArrayCreate([0, 0], varVariant);
    filterType[0] := 0;
    filterData[0] := 'LINE';

    doc := app.ActiveDocument;
    ss := doc.ActiveSelectionSet;
    ss.Clear;
    try
      ss.SelectOnScreen(filterType, filterData);
      if  ss.Count > 1 then begin
        //doc.StartUndoMark; // ĂȂ
        for i := 0 to ss.Count -2 do begin
          lin1 := ss.Item[i] as IAcadLine;
          for j := i+1 to ss.Count -1 do begin
            lin2 := ss.Item[j] as IAcadLine;
            if IsOnTheSameLine2(lin1.StartPoint, lin1.EndPoint,
                                lin2.StartPoint, lin2.EndPoint, 10e-10) then begin
              maxDist4p(lin1.StartPoint, lin1.EndPoint,
                          lin2.StartPoint, lin2.EndPoint,
                          respt1, respt2);
              lin2.StartPoint := respt1;
              lin2.EndPoint := respt2;
              lin2.Update;

              lin1.Delete;
              break;
            end;
          end;
        end;
        //doc.EndUndoMark; // ĂȂ
      end;
    except

    end;
  except

  end;
end;

procedure TForm72.Button1Click(Sender: TObject);
// NnanoCAD 擾
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
begin
  Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  try
    Memo1.Lines.Add(app.Path);
    doc := app.ActiveDocument;
    Memo1.Lines.Add(doc.FullName);
  except
  end;
end;

procedure TForm72.Button20Click(Sender: TObject);
// ƃubŇ_
// \ƂȂĂubN̓}`Ƃ̌_ΏۂɂȂ邽߁Aps
var
  app: InanoCADApplication;
  doc : InanoCADDocument;
  vlin, vblk, pick: oleVariant;
  ret: boolean;
  //blk: IAcadMInsertBlock;
  vpts, respt1, respt2: oleVariant;
  l, h: integer;
  //i: Integer;
begin
  ret := False;
  if not FindNcadApp(app, true) then exit;
  try
    doc := app.ActiveDocument;
    try
      doc.Utility.GetEntity(vlin, pick, 'I');
    except
    end;
    if not VarIsEmpty(vlin) then begin
      Memo1.Lines.Add(vlin.EntityName);
      if 'AcDbLine' = vlin.EntityName then begin
        try
          doc.Utility.GetEntity(vblk, pick, 'ubNI');
        except
        end;
        if not VarIsEmpty(vblk) then begin
          Memo1.Lines.Add(vblk.EntityName);
          if 'AcDbBlockReference' = vblk.EntityName then begin
            Memo1.Lines.Add('true');
            ret:= True;
          end;
        end;
      end;
    end;
    if ret then begin
      vpts := vblk.IntersectWith(vlin, acExtendNone);
      l := VarArrayLowBound(vpts, 1);
      h := VarArrayHighBound(vpts, 1);
      Memo1.Lines.Add(l.ToString);
      Memo1.Lines.Add(h.ToString);

      // 3dWx n  n = (h+1) div 3
      if maxDistVpts3d(vpts, respt1, respt2) > 0 then begin
        doc.ModelSpace.AddCircle(respt1, 0.5);
        doc.ModelSpace.AddCircle(respt2, 0.5);
      end
      else begin
        doc.ModelSpace.AddCircle(respt1, 0.5);
      end;
    end;
  except
    Memo1.Lines.Add('error');
  end;
end;

function vpts2dTo3d(vpts2d: oleVariant):OleVariant;
// 2D W3DWɕϊ
var
  h, i: integer;
begin
  h := VarArrayHighBound(vpts2d, 1);
  result := VarArrayCreate([0, (h + 1) div 2 * 3 -1], VarDouble);
  for i := 0 to (h + 1) div 2 -1 do begin
    result[i*3]    := vpts2d[i*2];
    result[i*3 +1] := vpts2d[i*2 +1];
    result[i*3 +2] := 0;
  end;
end;
function vpts3dTo2d(vpts3d: oleVariant):OleVariant;
// 3D W2DWɕϊ
var
  h, i: integer;
begin
  h := VarArrayHighBound(vpts3d, 1);
  result := VarArrayCreate([0, (h + 1) div 3 * 2 -1], VarDouble);
  for i := 0 to (h + 1) div 3 -1 do begin
    result[i*2]    := vpts3d[i*3];
    result[i*2 +1] := vpts3d[i*3 +1];
  end;
end;

function IsInside(vpt, vpts: OleVariant): boolean;
// wW LWPOLYLINE 2dW̕̈ł邩
  function angleCorr(ang: Double): double;
  begin
    result := ang;
    while result < -pi do result := result + pi * 2.0;
    while result >  pi do result := result - pi * 2.0;
  end;
var
  vpt1, vpt2: OleVariant;
  h, i: integer;
  ang, ang1, ang2, diff: double;
begin
  vpt1 := VarArrayCreate([0, 1], varDouble);
  vpt2 := vpt1;
  h := VarArrayHighBound(vpts, 1);
  VarArrayRedim(vpts, h +2);
  vpts[h + 1] := vpts[0];
  vpts[h + 2] := vpts[1];
  h:= h + 2;
  //ret := (abs(vpts[0] - vpts[hbnd-1]) < 10e-13) and (abs(vpts[1] - vpts[hbnd]) < 10e-13)
  ang := 0;
  for i := 0 to (h + 1) div 2 -2 do begin
    vpt1[0] := vpts[i*2];
    vpt1[1] := vpts[i*2 +1];
    vpt2[0] := vpts[i*2 +2];
    vpt2[1] := vpts[i*2 +3];
    ang1 := getAngle(vpt, vpt1);
    ang2 := getAngle(vpt, vpt2);
    diff := angleCorr(ang2 - ang1);
    ang  := ang + diff;
  end;
  // Inside = 360.0 ,Outside = 0.0
  result := not (abs(ang) < 0.01);
end;

// R}hI҂
// ߂lF add=2, timeout=0, enter=1, esc=-1;
function waitForCommandEnd(doc: InanoCadDocument; addFlag: boolean; maxsec: Cardinal): integer;
var
  ncadState: InanoCADState;
  //i: integer;
  ticks: Cardinal;
  //s: string;
  cnt: integer;
begin
  result := 0;
  cnt := doc.ModelSpace.Count;
  ticks := getTickCount;
  try
    ncadState := doc.Application.GetState as InanoCADState;
    while True do begin
      Sleep(100);
      vcl.Forms.Application.ProcessMessages; // d
      if addFlag then begin
        if doc.ModelSpace.Count > cnt then begin
          result := 2;
          break;
        end;
      end;
      if result = 0 then begin
        if GetKeyState( VK_ESCAPE ) < 0 then begin
          result:= -1;
          break;
        end
        else if ncadState.IsQuiescent then begin
          result := 1;
          break;
        end
        else if (getTickCount-ticks) > (maxsec * 1000) then break;
      end;
    end;
  except
  end;
end;
// line 2_͂4_𓾂
function linToPloygon(vpt1, vpt2: OleVariant; offset:double): OleVariant;
var
  vpts: array [0..3] of OleVariant;
  i: integer;
  ang: double;
  dist: double;
begin
  for i := 0 to 3 do
    vpts[i] := VarArrayCreate([0, 2], VarDouble);

  ang := getAngle(vpt1, vpt2);
  dist := offset * 1.41421356;
  vpts[0] := getPolar(vpt1, ang + pi * 0.75, dist);
  vpts[1] := getPolar(vpt1, ang + pi * 1.25, dist);
  vpts[2] := getPolar(vpt2, ang - pi * 0.25, dist);
  vpts[3] := getPolar(vpt2, ang + pi * 0.25, dist);
  result := VarArrayCreate([0, 11], VarDouble);
  for i := 0 to 2 do begin
    result[i]   := vpts[0][i];
    result[i+3] := vpts[1][i];
    result[i+6] := vpts[2][i];
    result[i+9] := vpts[3][i];
    //result[i+12]:= vpts[0][i];
  end;
end;

procedure doBlockTrim(doc: InanoCadDocument; const blkHnd: string);//: IAcadBlockReference);
var
  vpts, vpts3d, vpt1, vpt2: oleVariant;
  lwp: IAcadLWPolyline;
  ss: InanoCadSelectionSet;
  filterType, filterData: OleVariant;
  lin, lin1: IAcadLine;
  i, j, h: Integer;
  blk: IAcadBlockReference;
begin
  try
    blk := doc.HandleToObject(blkHnd) as IAcadBlockReference;
    if getBlockRealRect(doc, blk, 0, vpts) then begin
      // ubNɂ擾
      filterType := VarArrayCreate([0, 0], varSmallInt);
      filterData := VarArrayCreate([0, 0], varVariant);
      filterType[0] := 0;
      filterData[0] := 'LINE';

      ss := doc.ActiveSelectionSet;
      ss.Clear;
      // vpts 3d WKv
      vpts3d := vpts2dTo3d(vpts);
      ss.SelectByPolygon(acSelectionSetCrossingPolygon, vpts3d, filterType, filterData);
      if ss.Count > 0 then begin
        vpt1 := VarArrayCreate([0, 2], VarDouble);
        vpt2 := vpt1;
        // lwp ̍W 2dW
        lwp := doc.ModelSpace.AddLightWeightPolyline(vpts);
        lwp.Closed := True;
        lwp.Visible := False;
        try
          try
            for i := 0 to ss.Count -1 do begin
              lin := ss.Item[i] as IAcadLine;
              // 3dW
              vpts3d := lin.IntersectWith(lwp, acExtendNone);
              h := VarArrayHighBound(vpts3d, 1);
              if h = 5 then begin // _2
                for j := 0 to 2 do begin
                  vpt1[j] := vpts3d[j];
                  vpt2[j] := vpts3d[j+3];
                end;
                lin1 := lin.Copy as IAcadLine;
                if getDistance(lin.StartPoint, vpt1) < getDistance(lin.StartPoint, vpt2) then begin
                  lin.EndPoint := vpt1;
                  lin1.StartPoint := vpt2;
                end
                else begin
                  lin.EndPoint := vpt2;
                  lin1.StartPoint := vpt1;
                end;
              end
              else if h = 2 then begin // _1
                for j := 0 to 2 do
                  vpt1[j] := vpts3d[j];
                if IsInside(lin.StartPoint, vpts) then
                  lin.StartPoint := vpt1
                else if IsInside(lin.EndPoint, vpts) then
                  lin.EndPoint := vpt1;
              end;
            end;
          except
          end;
        finally
          lwp.Delete;
        end;
      end;
    end;
  except
  end;
end;

procedure TForm72.Button21Click(Sender: TObject);
// u bN̋`͈́iubN̓}`擾j
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  vpt: OleVariant;
  vobj: OleVariant;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  // ubN̋`͈́i 擾̋`͈͂]j
  try
    doc := app.ActiveDocument;
    WindowState:= wsMinimized;
    vobj := VarEmpty;
    doc.Utility.GetEntity(vobj, vpt, 'ubNI');
    if not VarIsEmpty(vobj) then begin
      if 'AcDbBlockReference' = vobj.EntityName then begin
        Memo1.Lines.Add(vobj.Handle);
        doBlockTrim(doc, vobj.Handle);
      end;
    end;
  except
  end;
  WindowState:= wsNormal;
end;


procedure LineJoint(ss: InanoCadSelectionSet);
var
  i, j, len: integer;
  lin1, lin2: IAcadLine;
  respt1, respt2: OleVariant;
begin
  len := ss.Count;
  if len > 1  then begin
    for i := 0 to len -2 do begin
      lin1 := ss.Item[i] as IAcadLine;
      for j := i+1 to len -1 do begin
        lin2 := ss.Item[j] as IAcadLine;
        if IsOnTheSameLine2(lin1.StartPoint, lin1.EndPoint,
                            lin2.StartPoint, lin2.EndPoint, 10e-10) then begin
          if (lin1.Layer = lin1.Layer) and (lin1.linetype = lin1.linetype) and
             (lin1.color = lin1.color) then begin

            maxDist4p(
                    lin1.StartPoint, lin1.EndPoint,
                    lin2.StartPoint, lin2.EndPoint,
                    respt1, respt2);
            lin2.StartPoint := respt1;
            lin2.EndPoint := respt2;
            lin2.Update;

            lin1.Delete;
            break;
          end
          else begin
            // EEEE
          end;
        end;
      end;
    end;

  end;
end;

procedure TForm72.Button22Click(Sender: TObject);
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  vpt: OleVariant;
  vobj: OleVariant;

  vpts, vpts3d: OleVariant;
  ss: InanoCadSelectionSet;
  filterType, filterData: OleVariant;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  // ubN̋`͈́i 擾̋`͈͂]j
  try
    doc := app.ActiveDocument;
    WindowState := wsMinimized;
    vobj := VarEmpty;
    doc.Utility.GetEntity(vobj, vpt, 'ubNI');
    if not VarIsEmpty(vobj) then begin
      if 'AcDbBlockReference' = vobj.EntityName then begin
        // I͈̔͂0.01mm ̋`AJbg̓ItZbg̋`Kv
        if getBlockRealRect(doc, vobj, 0, vpts) then begin
          // ubNɂ擾
          filterType := VarArrayCreate([0, 0], varSmallInt);
          filterData := VarArrayCreate([0, 0], varVariant);
          filterType[0] := 0;
          filterData[0] := 'LINE';
          ss := doc.ActiveSelectionSet;
          ss.Clear;

          // vpts 3d WKv
          vpts3d := vpts2dTo3d(vpts);
          ss.SelectByPolygon(acSelectionSetCrossingPolygon, vpts3d, filterType, filterData);
          Memo1.Lines.Add(IntToStr(ss.Count));
          LineJoint(ss);
        end;
      end;
    end;
  except
  end;
  WindowState:= wsNormal;
end;

procedure TForm72.Button23Click(Sender: TObject);
// PƐ̍쐬
var
  app: InanoCADApplication;
  doc : InanoCADDocument;
  ret: integer;
  ent: IAcadEntity;
  lin: IAcadLine;
begin
  Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  try
    doc := app.ActiveDocument;
    WindowState := wsMinimized;
    doc.SendCommand('line'+#13);
    // add= 2, esc=-1, enter=1, timeout=0
    ret := waitForCommandEnd(doc, true, 60);
    if ret = 2 then
      doc.SendCommand('^C');

    Memo1.Lines.Add(ret.ToString);
    WindowState := wsNormal;
    if ret = 2 then begin
      // Ōɒǉꂽ}`
      ent := doc.ModelSpace.Item(doc.ModelSpace.Count-1);
      Memo1.Lines.Add(ent.EntityName);
      // Ô߂ɊmF
      if ent.EntityName = 'AcDbLine' then begin
        lin := ent as IAcadLine;
        lin.color := acCyan;
      end;
    end;
  except
  end;
end;

procedure TForm72.Button24Click(Sender: TObject);
// wQ_̒ɂubN
type
  Fblk = record
    sHnd: string; // Handle
  end;
var
  app: InanoCADApplication;
  doc : InanoCADDocument;
  vpt1, vpt2, vpts: OleVariant;
  ss: InanoCadSelectionSet;
  filterType, filterData: OleVariant;
  i, len:integer;
  blkAry: array of FBlk;
  blk: IAcadBlockReference;
  ret: integer;
  ent: IAcadEntity;
  lin: IAcadLine;
begin
  if not FindNcadApp(app, true) then exit;
  try
    memo1.Lines.Clear;
    doc := app.ActiveDocument;
    WindowState := wsMinimized;
    doc.SendCommand('line'+#13);
    // add= 2, esc=-1, enter=1, timeout=0
    ret := waitForCommandEnd(doc, true, 60);
    if ret = 2 then
      doc.SendCommand('^C');

    Memo1.Lines.Add(ret.ToString);
    WindowState := wsNormal;
    if ret = 2 then begin
      // Ōɒǉꂽ}`
      ent := doc.ModelSpace.Item(doc.ModelSpace.Count-1);
      Memo1.Lines.Add(ent.EntityName);
      // Ô߂ɊmF
      if ent.EntityName = 'AcDbLine' then begin
        lin := ent as IAcadLine;
        vpt1 := lin.StartPoint;
        vpt2 := lin.EndPoint;
      end;
    end;
    if not VarIsEmpty(vpt1) and not VarIsEmpty(vpt2) then begin
      vpts := linToPloygon(vpt1, vpt2, 0.01);
      ss := doc.ActiveSelectionSet;


      filterType := VarArrayCreate([0, 0], varSmallInt);
      filterData := VarArrayCreate([0, 0], varVariant);
      filterType[0] := 0;
      // 
      ss.Clear;
      filterData[0] := 'LINE';
      ss.SelectByPolygon(acSelectionSetCrossingPolygon, vpts, filterType, filterData);
      if ss.Count > 0 then
        LineJoint(ss);

      // ubNɌvJbg
      ss.Clear;
      filterData[0] := 'INSERT';
      // Bꓮ̂ꁫ   Select(acSelectionSetFence, ...) ͑ʖ
      ss.SelectByPolygon(acSelectionSetCrossingPolygon, vpts, filterType, filterData);
      // IZbgpĂ邽ߐ}`̃nhL
      if ss.Count > 0 then begin
        SetLength(blkAry, ss.Count);
        for i := 0 to ss.Count -1 do begin
          blk := ss.Item[i] as IAcadBlockReference;
          with blkAry[i] do begin
            sHnd := blk.Handle;
          end;
        end;
      end;

      // ubN̋`ŃJbg
      len := Length(blkAry);
      if len > 0 then begin
        for i := 0 to len-1 do
          doBlockTrim(doc, blkAry[i].sHnd);
      end;
    end;
  except
  end;
end;

procedure TForm72.Button2Click(Sender: TObject);
var
  app: InanoCADApplication;
  doc : InanoCADDocument;
  ncadState: InanoCADState;
  i, mspccnt: integer;
begin
  Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  try
    doc := app.ActiveDocument;

    // LZMiR}hsłLZj
    doc.SendCommand(^C^C);
    // + ͏ȗł
    doc.SendCommand('line'#13'0,0'#13'420,297'#13#13);
    // Âق₷
    doc.SendCommand('line' + #13 + '0,297' + #13 + '420,0' + #13#13);
    doc.SendCommand('circle' + #13 + '210,148.5' + #13 + '148.5' + #13);

    // R}h̏I҂
    // Iǂ͕Ȃ
    // Ƃ΁Aȉ̂悤Ȋ
    WindowState:= wsMinimized;

    doc.SendCommand('line'+#13);
    // R}h̏I҂
    mspccnt:= doc.ModelSpace.Count;
    for i := 0 to (60 * 1000 div 100) -1 do begin  // 񐔐œKɏIقS
      Sleep(100);
      vcl.Forms.Application.ProcessMessages; // dv

      if GetKeyState( VK_ESCAPE ) < 0 then begin
        doc.Utility.Prompt('COMMAND Cancelled!');
        break;
      end
      else begin
        ncadState := app.GetState as InanoCADState;
  @@@if ncadState.IsQuiescent then begin
          doc.Utility.Prompt('COMMAND Terminated!');
          break;
        end;
      end;
    end;
    doc.Utility.Prompt(IntToStr(doc.ModelSpace.Count - mspccnt) +
      ' ̐}`쐬܂.');

  except
    ShowMessage('ERROR');
  end;
  WindowState:= wsNormal;
end;

procedure TForm72.Button3Click(Sender: TObject);
// W̎擾
var
  app: InanoCADApplication;
  doc : InanoCADDocument;
  vpt1, vpt2, vpt3, vpt4: OleVariant;
  line: IAcadLine;
  circle: IAcadCircle;
begin
  Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  // W̎擾
  try
    doc := app.ActiveDocument;
    WindowState:= wsMinimized;

    // nanoCAD 炤l͂̂܂܎g
    vpt1 := doc.Utility.GetPoint(emptyParam, 'n_w:');
    // W̎o
    Memo1.Lines.Add(FloatToStr(vpt1[0])+', '+FloatToStr(vpt1[1]));
    Memo1.Lines.Add(Format('%.3f, %.3f', [Double(vpt1[0]),Double(vpt1[1])]));

    // o[oh͕\Ȃ
    vpt2 := doc.Utility.GetPoint(vpt1, 'I_w:');
    // GetCorner Ƌ`͈͂\
    //vpt2 := doc.Utility.GetCorner(vpt1, 'I_w:');

    // 쐬
    line := doc.ModelSpace.AddLine(vpt1, vpt2);
    line.color:= acCyan;

    // 3D Wp
    vpt3 := VarArrayCreate([0, 2], VarDouble);
    vpt3[0] := 420;
    vpt3[1] := 297;
    vpt3[2] := 0;
    circle := doc.ModelSpace.AddCircle(vpt3, 210);

    // vpt4 := vpt3;  // łǂ
    vpt4 := VarArrayCreate([0, 2], VarDouble);
    vpt4[0] := 0;
    vpt4[1] := 0;
    vpt4[2] := 0;
    app.ZoomWindow(vpt3, vpt4);
  except

  end;
  WindowState := wsNormal;
end;

procedure TForm72.Button4Click(Sender: TObject);
var
  app: InanoCADApplication;
  doc : InanoCADDocument;
  ss: InanoCADSelectionSet;
  i: integer;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  // }`̑IitB^[Ȃj
  try
    doc := app.ActiveDocument;
    ss := doc.ActiveSelectionSet;
    ss.Clear;
    try
      WindowState:= wsMinimized;
      ss.SelectOnScreen(EmptyParam, EmptyParam);
      if ss.Count > 0 then begin
        for i := 0 to ss.Count -1 do begin
          Memo1.Lines.Add(ss.Item[i].EntityName);
        end;
      end;
    except
    end;
  except
  end;
  WindowState := wsNormal;
end;

procedure TForm72.Button5Click(Sender: TObject);
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  vpt: OleVariant;
  obj: OleVariant;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  // P}`̑I
  try
    doc := app.ActiveDocument;
    try
      WindowState:= wsMinimized;
      obj:= VarEmpty;
      doc.Utility.GetEntity(obj, vpt, '}`I');
      if not VarIsEmpty(obj) then begin
        Memo1.Lines.Add(obj.EntityName);
      end;
    except
    end;
  except
  end;
  WindowState:= wsNormal;
end;

procedure TForm72.Button6Click(Sender: TObject);
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  filterType, filterData: OleVariant;
  ss: InanoCADSelectionSet;
  i: integer;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  // }`̑IitB^[j
  try
    filterType := VarArrayCreate([0, 1], varSmallInt);
    filterData := VarArrayCreate([0, 1], varVariant);
    filterType[0] := 8; // w
    filterData[0] := '0,TEST';
    filterType[1] := 0; // }`
    filterData[1] := 'TEXT,*LINE'; // }`́ADXFO[vR[h 0: GeBeB\^Cv

    doc := app.ActiveDocument;
    ss := doc.ActiveSelectionSet;
    ss.Clear;
    try
      WindowState := wsMinimized;
      ss.SelectOnScreen(filterType, filterData);
      if ss.Count > 0 then begin
        for i := 0 to ss.Count -1 do begin
          Memo1.Lines.Add(ss.Item[i].EntityName);
        end;
      end;
    except
    end;
  except
  end;
  WindowState := wsNormal;
end;

procedure TForm72.Button7Click(Sender: TObject);
// |C̍쐬
type
  TDblAry = array of Double;
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  lwp: IAcadLWPolyline;
  vpts: OleVariant;
  ary: TDblAry; // _WpIz
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  // |C̍쐬
  try
    doc := app.ActiveDocument;

    // Izg----------------------
    SetLength(ary, 8); // 2D - 4_
    ary[0] := 100; ary[1] := 200;
    ary[2] := 300; ary[3] := 200;
    ary[4] := 300; ary[5] := 0;
    ary[6] := 100; ary[7] := 0;
    DynArrayToVariant(Variant(vpts), ary, TypeInfo(TDblAry));
    lwp := doc.ModelSpace.AddLightWeightPolyline(vpts);

    lwp.Closed := True; // 
    lwp.color := acCyan;

    // IzgȂ-------------
    // VarClear(vpts);// N̂ߋɂ
    vpts := VarArrayCreate([0, 7], VarDouble);
    vpts[0] := 200; vpts[1] := 100;
    vpts[2] := 200; vpts[3] := 300;
    vpts[4] := 0; vpts[5] := 300;
    vpts[6] := 0; vpts[7] := 100;
    lwp := doc.ModelSpace.AddLightWeightPolyline(vpts);
    lwp.color := acYellow;
    lwp.Closed := True; // 
    // _ǉ鎞
//    vpt := VarArrayCreate([0, 1], VarDouble);
//    vpt[0] := vpts[0];
//    vpt[1] := vpts[1];
//    // _ǉ
//    lwp.AddVertex(4, vpt);
  except
  end;
end;

procedure TForm72.Button8Click(Sender: TObject);
// 
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  vpt1, vpt2 : OleVariant;
  layout: IAcadLayout;
  plot: InanocadPlot;
  previewFlag: boolean;
  rotDeg: integer;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;

  // 
  previewFlag := True;
  try
    doc := app.ActiveDocument;
    WindowState:= wsMinimized;
    try
      vpt1 := doc.Utility.GetPoint(emptyParam, '͈͂ 1 _ڂw');
      vpt2 := doc.Utility.GetCorner(vpt1, '2 _ڂw');
    except
      WindowState:= wsNormal;
    end;
    if not PreviewFlag then
      WindowState:= wsNormal;

    if not (VarIsEmpty(vpt1) or VarIsEmpty(vpt2)) then begin
      layout := doc.ActiveLayout;
      layout.RefreshPlotDeviceInfo;
      rotDeg:= 90; // ]px

      layout.ConfigName := 'pdfFactory';
      layout.CanonicalMediaName := 'A4';
      layout.PlotRotation := rotDeg div 90; // 0, 90, 180, 270 = 0..3 ex: ac90degrees;
      layout.StyleSheet:= 'monochrome.ctb';

      layout.PlotWithPlotStyles := True; // 'False = monochrome ɂȂȂ
      //layout.PlotViewportBorders := False;// 'r[|[gE
      //layout.PlotViewportsFirst := True;// 'y[p[Ԃ̃r[|[g̃WIgŏɈ

      layout.PlotWithLineweights := True; // 't@CŊ蓖ĂĂ̑gp
      layout.ScaleLineweights := True; // '̑ɂړxKp

      layout.PaperUnits := acMillimeters;
      layout.ShowPlotStyles := False;

      //acDisplay, acExtents, acLimits, acView, acWindow, acLayout
      layout.PlotType := acWindow;
      layout.SetWindowToPlot(vpt1, vpt2);

      layout.CenterPlot := True;
      layout.UseStandardScale := False;

      layout.SetCustomScale(1.0, 1.414);// 1.414 '  qȀ

      // ύX𔽉f
      layout.RefreshPlotDeviceInfo;

      doc.Activate;
      // ړxύX̂ߍč}KvH
      doc.Regen(acAllViewports);
      doc.Utility.Prompt(layout.ConfigName);

      // s
      //idisp:= doc.plot;
      //plot := idisp as InanocadPlot;
      plot := doc.plot as InanocadPlot;
      plot.NumberOfCopies := 1;

      previewFlag:= True;
      if previewFlag then begin
      @//WindowState:= wsMinimized;
        //acPartialPreview(I), acFullPreview
        plot.DisplayPlotPreview(acPartialPreview);
        WindowState:= wsNormal;
      end
      else begin
        plot.PlotToDevice(emptyParam);
      end;
      doc.Utility.Prompt('Printing : '+ doc.FullName);
    end;
  except
  end;
  WindowState := wsNormal;
end;

procedure TForm72.Button9Click(Sender: TObject);
// ubN̋`͈́i̋`͈͂擾j
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  vpt: OleVariant;
  vobj: OleVariant;
  vents: oleVariant;
  l, h: integer;
  i, j, cnt: Integer;
  s: string;
  vpt1, vpt2, vpts: oleVariant;
  vmaxpt, vminpt: oleVariant;
  lwp: IAcadLWPolyline;
  slay: string;
  sl: TstringList;
  Ticks: Cardinal;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  // ubN̋`͈́i]̋`͈́j
  try
    doc := app.ActiveDocument;
    try
      vobj := VarEmpty;
      WindowState := wsMinimized;
      doc.Utility.GetEntity(vobj, vpt, 'ubNI');
      if not VarIsEmpty(vobj) then begin
        //Memo1.Lines.Add(vobj.EntityName);
        if 'AcDbBlockReference' = vobj.EntityName then begin
          sl := TStringList.Create;
          try
            Ticks := GetTickCount;
            makelayerOnlist(doc, sl);
            vents := vobj.Explode; // 
            if VarIsArray(vents) then begin
              vmaxpt := doc.GetVariable('extmin');
              vminpt := doc.GetVariable('extmax');
              cnt := 0;
              // z̉
              l := VarArrayLowBound(vents, 1);
              // z̏
              h := VarArrayHighBound(vents, 1);
              Memo1.Lines.Add(h.ToString);
              for i := l to h do begin
                s := vents[i].EntityName;
                //Memo1.Lines.Add(s);

                if ('AcDbCircle' = s) or ('AcDbArc' = s) or  ('AcDbLine' = s) or ('AcDbPolyline' = s) then begin
                  slay := vents[i].Layer;
                  //Memo1.Lines.Add(slay);
                  if sl.IndexOf(Uppercase(slay)+#09) >= 0 then begin
                  @//Memo1.Lines.Add('ON:'+slay);
                    vents[i].GetBoundingBox(vpt1, vpt2);
                    for j := 0 to 1 do begin
                      if vmaxpt[j] < vpt1[j] then vmaxpt[j] := vpt1[j];
                      if vminpt[j] > vpt1[j] then vminpt[j] := vpt1[j];
                      if vmaxpt[j] < vpt2[j] then vmaxpt[j] := vpt2[j];
                      if vminpt[j] > vpt2[j] then vminpt[j] := vpt2[j];
                    end;
                    Inc(cnt);
                  end
                  else begin
                    //Memo1.Lines.Add('OFF:'+slay);
                  end;
                end;
                vents[i].Delete;
              end;
              Memo1.Lines.Add('cnt='+ cnt.ToString);
              if cnt > 0 then begin
                vpts := VarArrayCreate([0, 7], VarDouble);
                for j := 0 to 1 do begin
                  vpts[j]   := vminpt[j];
                  vpts[j+4] := vmaxpt[j];
                end;
                vpts[2] := vmaxpt[0];
                vpts[3] := vminpt[1];
                vpts[6] := vminpt[0];
                vpts[7] := vmaxpt[1];
                lwp := doc.ModelSpace.AddLightWeightPolyline(vpts);
                lwp.Closed := True;
              end;
            end;
            Memo1.Lines.Add((GetTickCount-Ticks).ToString+ 'msec');
          finally
            sl.Free;
          end;
        end;
      end;
    except
    end;
  except
  end;
  WindowState:= wsNormal;
end;

procedure TForm72.ComboBox1Change(Sender: TObject);
// 
var
  app: InanoCADApplication;
  doc: InanoCADDocument;
  layout : IAcadLayout;
  papernames: oleVariant;
  i, n: integer;
begin
@Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;
  // 
  try
    doc := app.ActiveDocument;

    layout := doc.ActiveLayout;
    layout.RefreshPlotDeviceInfo;
    with ComboBox1 do
      layout.ConfigName := Items[ItemIndex];
    layout.RefreshPlotDeviceInfo;

    Memo1.Lines.Add(' Paper ---------');
    papernames := layout.GetCanonicalMediaNames;

    n := VarArrayHighBound(papernames, 1);
    if n >= 0 then begin
      for i := 0 to n  do
        Memo1.Lines.Add(layout.GetLocaleMediaName(papernames[i]));
    end;
   except

  end;
end;

procedure TForm72.FormCreate(Sender: TObject);
var
  ini: TIniFile;
begin
  ini := TIniFile.Create(ChangeFileExt(paramStr(0), '.ini'));
  try
    Left := ini.ReadInteger('Form', 'Left', (Screen.Width - Width) div 2);
    Top  := ini.ReadInteger('Form', 'Top', (Screen.Height - Height) div 2);
    if (Left + Width) > Screen.Width then
      Left := Screen.Width - Width;
    if (Top + Height) > Screen.Height then
      Top := Screen.Height - Height;
  finally
    ini.Free;
  end;
end;

procedure TForm72.FormDestroy(Sender: TObject);
var
  ini: TIniFile;
begin
  ini := TIniFile.Create(ChangeFileExt(paramStr(0), '.ini'));
  try
    ini.WriteInteger('Form', 'Left', Left);
    ini.WriteInteger('Form', 'Top', Top);
  finally
    ini.Free;
  end;
end;

procedure TForm72.Button25Click(Sender: TObject);
var
  app: InanoCADApplication;
  doc : InanoCADDocument;
  ///ret: integer;
  //ent: IAcadEntity;
  //lin: IAcadLine;
  vobj, vpt: OleVariant;
  ss: InanoCadSelectionSet;
begin
  Memo1.Lines.Clear;
  if not FindNcadApp(app, true) then exit;


  try

    vobj := VarEmpty;
    doc := app.ActiveDocument;
    doc.SendCommand('C^C');
    WindowState := wsMinimized;





    doc.Utility.GetEntity(vobj, vpt, 'ړubNI');
    if not VarIsEmpty(vobj) then begin
      if 'AcDbBlockReference' = vobj.EntityName then begin
        ss := Doc.ActiveSelectionSet;
        ss.Clear;
        ss.SelectAtPoint(vpt, EmptyParam, EmptyParam);
        Memo1.Lines.Add(ss.Count.ToString);

      end;
    end;

  except

  end;
  WindowState := wsNormal;
end;

end.
